USE tempdb
GO




--Anyone have one of these?
CREATE PROC dbo.get_products
	@list_of_products NVARCHAR(4000)
AS
BEGIN
	SELECT
		*
	FROM dbo.products
	WHERE
		product_id IN
		(
			SELECT
				val
			FROM dbo.split(@list_of_products, ',')
		)
END
GO




--Finally!!!
SELECT
	*
FROM STRING_SPLIT('it''s.about.time', '.')
GO




--full-featured?
SELECT
	*
FROM STRING_SPLIT('...test.  test 2  . .     test3. .', '.')
GO





--...workable...
SELECT
	RTRIM(LTRIM(value))
FROM STRING_SPLIT('...test.  test 2  . .     test3. .', '.')
WHERE
	RTRIM(LTRIM(value)) <> ''
GO





--output row number?
SELECT
	RTRIM(LTRIM(value)),
	ROW_NUMBER() OVER (ORDER BY (SELECT NULL))
FROM STRING_SPLIT('...test.  test 2  . .     test3. .', '.')
WHERE
	RTRIM(LTRIM(value)) <> ''
GO







--Session context: this never worked very well

DECLARE @info VARBINARY(128) = CONVERT(VARBINARY, 'hello')

SET CONTEXT_INFO @info
GO


SELECT CONTEXT_INFO()
GO





--2016 ...

--Set a named slot
EXEC sys.sp_set_session_context 
	@key = N'my favorite password', 
	@value = 'p@ssw0rd'
GO


--retrieve a named slot
SELECT SESSION_CONTEXT(N'my favorite password')
GO




--Readonly values
EXEC sys.sp_set_session_context 
	@key = N'access_control_key', 
	@value = 0x00,
	@readonly = 1
GO



SELECT SESSION_CONTEXT(N'access_control_key')
GO



EXEC sys.sp_set_session_context 
	@key = N'access_control_key', 
	@value = 0x01
GO





 